#ifndef NULL
#include <stdlib.h>
#endif

#include "console.h"
#include "uimage.h"
#include "logging.h"
#include "usplash.h"

#define DEFAULT_IMAGE "media/ubuntu-orange-466x400.pcx"
#define AS_UFADEOUT "ufadeout"

int main(int argc, char **argv)
{
	uimage *fbimage, *pcximage, *pcximage2;
	int t;
	logme("using image: %s\n", DEFAULT_IMAGE);

	/* Check for framebuffer */
	if (!graphical_framebuffer_enabled())
		return 1;
	
	/* Are we getting called as ufadeout? */
	if (!strcmp(*argv + strlen(*argv) - strlen(AS_UFADEOUT), AS_UFADEOUT))
	  return uimage_display_on_fb(NULL, DISPTECH_FADEOUT);
	  
	/* Allocate our images */
	if ((fbimage = uimage_new()) == NULL)
		return 2;

	if ((pcximage = uimage_new()) == NULL)
		return 3;
	if ((pcximage2 = uimage_new()) == NULL)
		return 3;
	
	/* Get our images */
	if (uimage_from_framebuffer(fbimage))
		return 4;
	if (uimage_from_pcx(pcximage, DEFAULT_IMAGE))
		return 5;
	if (uimage_from_pcx(pcximage2, "media/ubuntu-orange-466x400-r.pcx"))
		return 15;
	
	/* Make pcx fit framebuffer */
	if (t = uimage_fill_to_size(pcximage, fbimage->width, fbimage->height))
		return 6 - t*10 ;
	if (t = uimage_fill_to_size(pcximage2, fbimage->width, fbimage->height))
		return 6 - t*10 ;
	if (uimage_convert_depth(pcximage, fbimage->depth))
		return 7;
	if (uimage_convert_depth(pcximage2, fbimage->depth))
		return 7;
	
	/* Prepare our console */
	disable_cursor(SPLASH_CON);
	clear_console(SPLASH_CON);
	change_console(SPLASH_CON);

	/* Display our image */
	if (t = uimage_display_on_fb(pcximage2, DISPTECH_FADEIN))
	  ;
	/*
	if (t = uimage_display_on_fb(pcximage, DISPTECH_CROSSFADE))
	  ;
	if (t = uimage_display_on_fb(NULL, DISPTECH_FADEOUT))
	  ;
	*/
	//if (t = uimage_display_on_fb(pcximage, DISPTECH_CUT))
		return 8 - t*10;

	return 0;
}



