/* States */
#define MSG_ATTEMPT_RUN "attempt_run"
#define MSG_RUN_STATUS_SUCCESS "run_status_success"
#define MSG_RUN_STATUS_FAILURE "run_status_failure"
#define MSG_PERCENT "percent"
#define MSG_EXIT "exit"

/* Misc */
#define VERSION "0.1"		/* Our interface version */
#define MAX_VT 12		/* Maximum terminal we will report */
#define SOCKET_LOCATION "/etc/usplash/.control/socket" /* Where the socket will be */
#define SOCKET_UMASK (0155) /* rw--w--w- */
#define EVENT_FORMAT_PSTRING "%s:%s:%s:%d"
#define EVENT_FORMAT_SSTRING "%[^:]:%[^:]:%[^:]:%d"

typedef struct {
	char *version;
	char *name;
	char *state;
	int value;
} s_event;

extern s_event *se_create(char *version, char *name, char *state, int value);
extern void se_free(s_event *event);
extern int se_strlen(s_event *event);
extern const char *se_to_string(s_event *event);
extern s_event *se_from_string(char *string);
extern int se_send(s_event *event, char *us_location);
extern void close_se_server();
extern int open_se_server(char *us_location, void (*callback)(s_event *));
extern void poll_se_server();
