#define MOUNT_COMMAND "/bin/mount -t %s %s %s"

#ifdef DEBUG
#define UMOUNT_COMMAND "/bin/umount %s"
#else
#define UMOUNT_COMMAND "/bin/umount %s >/dev/null 2>&1"
#endif

#define PROC_SUBDIR "/proc"
#define MOUNT 0
#define UMOUNT 1

/* Internal (don't use) */
extern char *get_tmpfs_mountpoint();
extern char *get_proc_mountpoint();
extern int mkdir_p(char *dir);
extern int mount(char *fstype, char *src, char *dest);
extern int umount(char *dest);

/* External high level (use these) */
extern int mount_tmpfs();
extern int umount_tmpfs();
extern int mount_proc();
extern int umount_proc();
