typedef struct {
  int r_right;  //  3
  int r_left;   // 11
  int g_right;  //  2
  int g_left;   //  5
  int b_right;  //  3
  int b_left;   //  0
} uimage_ordering;

typedef struct {
  int width;
  int height;
  int stride;
  int depth;
  void *data;
  char *colourmap;
  uimage_ordering order;
} uimage;

enum {
  UIMAGE_COLOUR_MAP_LENGTH = 256 * 3,
};

enum {
  DISPTECH_CUT = 0,
  DISPTECH_CROSSFADE = 1,
  DISPTECH_FADEOUT = 2,
  DISPTECH_FADEIN = 4,
  /* Other transitions go here */
};

#define UIMAGEH_INCLUDED

/*
** Allocates a new uimage 
*/
extern uimage *uimage_new(void);

/*
** Frees up an old image
*/
extern void uimage_free(uimage *image);

/*
** Copies the contents of the framebuffer into a uimage 
*/
extern int uimage_from_framebuffer(uimage *fbimage);

/*
** Creates a uimage from a pcx file
*/
extern int uimage_from_pcx(uimage *image, char *filename);

/*
** Displays the specified image on the framebuffer using specified technique
** NOTE: *ALL* conversion (bpp and size) must be done before displaying!
*/
extern int uimage_display_on_fb(uimage *image, int technique);

/*
** Converts the specified uimage to the specified color depth
*/
extern int uimage_convert_depth(uimage *image, int bpp);

/*
** Centers a uimage in the size specified and fills the rest 
** from the primary palette color.
*/
extern int uimage_fill_to_size(uimage *image, int width, int height);
